---
title: "Value Cache"
framework: javascript
version: "36.1.0"
---

# Value Cache

The Value Cache is for advanced users who have time-consuming Value Getters and want to reduce the number of times Value Getters get executed.

Each time the grid requires a value from a Value Getter, the Value Getter is executed. For most use cases, this will not be an issue, as Value Getters will execute quickly and not have any noticeable performance implications for your application. However sometimes you might implement time-intensive tasks in your Value Getters. If this is the case, then you can opt to turn on the Value Cache to store the results of the value getters.

If you are not using Value Getters, or you don't have performance problems, then you do not need the Value Cache.

When the Value Cache is turned on, each time a Value Getter is executed, its result is stored in the Value Cache. If the data in the grid has not changed since the last time the value getter was used, then the value is retrieved from the cache instead of executing the Value Getter again.

> **Note**
>
> One client of AG Grid had 1,000 rows and 20 columns in a grid. A lot of the columns were doing advanced maths, using third-party maths API in the valueGetter for 8 of the columns. The client was also grouping and the summing by the columns containing the value getters. This meant, if more rows were added, the grid recomputed the aggregations, resulting in all the value getters getting called again, causing the grid to stall for around 1,000ms as rows were added.
>
> Introducing the value cache meant the value getters were executed once when the initial data was loaded, so the 1,000ms happened once. Then when delta changes came in, the value getters were only executed on the new records, giving an almost seamless experience to the user.

Below shows a grid demonstrating the Value Cache. The column on the right has a Value Getter that has a `console.log()` statement. This will allow us to see exactly when the Value Getter is called. From the example, the following can be noted:

- When the grid is initially loaded, the **value getter is called over 100 times**. This is for the following reasons:
  - The aggregation requires each value for the group total.
  - The DOM requires each value that is displayed (because of scrolling, not all are displayed)
- As you **scroll up and down** the grid, the value getters are executed, as the DOM needs values for rendering.
- As you **open and close groups**, the value getters are executed, as the DOM needs values for rendering.
- Now turn the value cache **on** by selecting the radio button at the top. The grid gets reset and then works with the value cache on. Notice in the console that the value getter gets executed exactly 100 times, once for each row. Even through the value getter result is used in two places (aggregation and rendering the row), the value getter is only called once. Even scrolling and opening / closing the groups does not result in the value getter getting executed again.

#### Value Cache

```ts
import {
  CellStyleModule,
  ClientSideRowModelModule,
  ColDef,
  GetRowIdParams,
  GridApi,
  GridOptions,
  HighlightChangesModule,
  ModuleRegistry,
  ValueCacheModule,
  ValueFormatterParams,
  ValueGetterParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { getData } from "./data";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ValueCacheModule,
  HighlightChangesModule,
  CellStyleModule,
  ClientSideRowModelModule,
  RowGroupingModule,
]);

let callCount = 1;

const columnDefs: ColDef[] = [
  { field: "q1", type: "quarterFigure" },
  { field: "q2", type: "quarterFigure" },
  { field: "q3", type: "quarterFigure" },
  { field: "q4", type: "quarterFigure" },
  { field: "year", rowGroup: true, hide: true },
  {
    headerName: "Total",
    colId: "total",
    cellClass: ["number-cell", "total-col"],
    aggFunc: "sum",
    valueFormatter: formatNumber,
    valueGetter: (params: ValueGetterParams) => {
      const q1 = params.getValue("q1");
      const q2 = params.getValue("q2");
      const q3 = params.getValue("q3");
      const q4 = params.getValue("q4");
      const result = q1 + q2 + q3 + q4;
      console.log(
        `Total Value Getter (${callCount}, ${params.column.getId()}): ${[q1, q2, q3, q4].join(", ")} =  ${result}`,
      );
      callCount++;
      return result;
    },
  },
];

let gridApi: GridApi;

const gridOptions: GridOptions = {
  columnDefs: columnDefs,
  defaultColDef: {
    flex: 1,
    enableCellChangeFlash: true,
  },
  autoGroupColumnDef: {
    minWidth: 140,
  },
  // we set the value cache in the function createGrid below
  // valueCache = true / false;
  columnTypes: {
    quarterFigure: {
      cellClass: "number-cell",
      aggFunc: "sum",
      valueFormatter: formatNumber,
      valueParser: function numberParser(params) {
        return Number(params.newValue);
      },
    },
  },
  rowData: getData(),
  suppressAggFuncInHeader: true,
  groupDefaultExpanded: 1,
  getRowId: (params: GetRowIdParams) => {
    return String(params.data.id);
  },
  onCellValueChanged: () => {
    console.log("onCellValueChanged");
  },
};

function formatNumber(params: ValueFormatterParams) {
  const number = params.value;
  return Math.floor(number).toLocaleString();
}

function onValueCache(valueCacheOn: boolean) {
  destroyOldGridIfExists();
  makeGrid(valueCacheOn);
}

function destroyOldGridIfExists() {
  if (gridApi!) {
    console.log("==========> destroying old grid");
    gridApi!.destroy();
  }
}

function makeGrid(valueCacheOn: boolean) {
  console.log("==========> creating grid");
  callCount = 1;
  gridOptions.valueCache = valueCacheOn;

  // then similar to all the other examples, create the grid
  const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
  gridApi = createGrid(gridDiv, gridOptions);
}

onValueCache(false);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onValueCache = onValueCache;
}
```

[Live example: Value Cache](https://www.ag-grid.com/examples/value-cache/value-cache/typescript/)

> **Note**
>
> Note that the example still works fast when the Value Cache is turned off. This emphasises you don't need to turn the Value Cache on if your application is not getting slowed down by your Value Getters.

### Value Cache Properties

The following are the grid properties related to the Value Cache.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `valueCache` | `boolean` |  | `false` | Set to `true` to turn on the value cache. Module: [`ValueCacheModule`](https://www.ag-grid.com/javascript-data-grid/modules/). [Initial](https://www.ag-grid.com/javascript-data-grid/grid-interface/#initial-grid-options). |
| `valueCacheNeverExpires` | `boolean` |  | `false` | Set to `true` to configure the value cache to not expire after data updates. Module: [`ValueCacheModule`](https://www.ag-grid.com/javascript-data-grid/modules/). [Initial](https://www.ag-grid.com/javascript-data-grid/grid-interface/#initial-grid-options). |

### Expiring the Value Cache

The Value Cache starts empty. Then as Value Getters execute, their results are stored and the Value Cache fills up. Certain events trigger the Value Cache to be emptied. This is called expiring the Value Cache. Once expired, every Value Getter will get executed again next time the value is needed. The events that cause the Value Cache to expire are the following:

- New row data is set into the grid via `setGridOption('rowData', newData)` API or changing the `rowData` framework bound property*.
- New columns are set into the grid via `setGridOption('columnDefs', columnDefs)` API or changing the `columnDefs` framework bound property*.
- Data is modified using the `rowNode.setData(data)` or `rowNode.setDataValue(col,value)` node API methods.
- A value is modified in the grid using the grid's UI editing feature, e.g. the user double clicks a cell and enters a new value.
- The `expireValueCache()` grid API method gets called by the application.

> **Note**
>
> - Assuming your framework allows binding properties and this is what you are using.

The first example above didn't have any editing, so there was no concern for expiring the Value Cache. This example introduces grid editing. The example differs from the last in the following ways:

- Value Cache is on.
- Editing is enabled.
- There are only 10 rows, so it's easier to count the number of cells.
- There is another column **'Total x10'** which also uses a value getter and references the original **'Total'** column, thus calling this value getter results in an additional call to the original value getter.

As before, we focus on the Value Getter of the **'Total'** column and can see how many times it gets called via the console. The following can be noted:

- The values in the **Total** column are used many times as follows:
  - For inserting the value into the DOM (i.e. what's visible in the cell).
  - For calculating the group total for the total column (ie the figure 870,400 is a sum of the 5 values below it).
  - For calculating the **'Total x 10'** column, as that value getter also references the values in the **'Total'** column.
- Despite the values getting used multiple times, each value getter is executed exactly once. This can be observed observing the log message the value getter prints.
- If you close and then re-open a group, the value getters are not re-executed, even though the values are needed to re-create the DOM elements that represent the cells.
- Hitting **'Refresh Cells'** will refresh all the cells, but again the value getters will not get re-executed.
- Hitting **'Invalidate Cache'** and then **'Refresh Cells'** will result in the value getters getting re-executed, as the cell refresh operation requires the values and the cache was invalidated. You will notice invalidating and then refreshing doesn't do anything noticeable to the grid, the data is the same, the only hint that anything happened is the value getter's console messages.
- Changing any value in the grid, either editing via the UI directly or hitting the **'Update One Value'** button, will result in the value cache getting cleared and all cells getting refreshed (where [change detection](https://www.ag-grid.com/javascript-data-grid/change-detection/) then updates any changes cells and only changed cells).

#### Expiring Cache through Editing

```ts
import {
  CellStyleModule,
  ClientSideRowModelModule,
  ColDef,
  GetRowIdParams,
  GridApi,
  GridOptions,
  HighlightChangesModule,
  ModuleRegistry,
  NumberEditorModule,
  RenderApiModule,
  RowApiModule,
  TextEditorModule,
  ValueCacheModule,
  ValueFormatterParams,
  ValueGetterParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { getData } from "./data";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowApiModule,
  RenderApiModule,
  NumberEditorModule,
  TextEditorModule,
  ValueCacheModule,
  HighlightChangesModule,
  CellStyleModule,
  ClientSideRowModelModule,
  RowGroupingModule,
]);

let callCount = 1;

const totalValueGetter = function (params: ValueGetterParams) {
  const q1 = params.getValue("q1");
  const q2 = params.getValue("q2");
  const q3 = params.getValue("q3");
  const q4 = params.getValue("q4");
  const result = q1 + q2 + q3 + q4;
  console.log(
    `Total Value Getter (${callCount}, ${params.column.getId()}): ${[q1, q2, q3, q4].join(", ")} = ${result}`,
  );
  callCount++;
  return result;
};
const total10ValueGetter = function (params: ValueGetterParams) {
  const total = params.getValue("total");
  return total * 10;
};

const columnDefs: ColDef[] = [
  { field: "q1", type: "quarterFigure" },
  { field: "q2", type: "quarterFigure" },
  { field: "q3", type: "quarterFigure" },
  { field: "q4", type: "quarterFigure" },
  { field: "year", rowGroup: true, hide: true },
  {
    headerName: "Total",
    colId: "total",
    cellClass: ["number-cell", "total-col"],
    aggFunc: "sum",
    valueFormatter: formatNumber,
    valueGetter: totalValueGetter,
  },
  {
    headerName: "Total x 10",
    cellClass: ["number-cell", "total-col"],
    aggFunc: "sum",
    minWidth: 120,
    valueFormatter: formatNumber,
    valueGetter: total10ValueGetter,
  },
];

let gridApi: GridApi;

const gridOptions: GridOptions = {
  columnDefs: columnDefs,
  defaultColDef: {
    flex: 1,
    enableCellChangeFlash: true,
  },
  autoGroupColumnDef: {
    minWidth: 130,
  },
  columnTypes: {
    quarterFigure: {
      editable: true,
      cellClass: "number-cell",
      aggFunc: "sum",
      valueFormatter: formatNumber,
      valueParser: function numberParser(params) {
        return Number(params.newValue);
      },
    },
  },
  rowData: getData(),
  suppressAggFuncInHeader: true,
  groupDefaultExpanded: 1,
  valueCache: true,
  getRowId: (params: GetRowIdParams) => {
    return String(params.data.id);
  },
  onCellValueChanged: () => {
    console.log("onCellValueChanged");
  },
};

function formatNumber(params: ValueFormatterParams) {
  const number = params.value;
  return Math.floor(number).toLocaleString();
}

function onExpireValueCache() {
  console.log("onInvalidateValueCache -> start");
  gridApi!.expireValueCache();
  console.log("onInvalidateValueCache -> end");
}

function onRefreshCells() {
  console.log("onRefreshCells -> start");
  gridApi!.refreshCells();
  console.log("onRefreshCells -> end");
}

function onUpdateOneValue() {
  const randomId = Math.floor(window.agRandom() * 10) + "";
  const rowNode = gridApi!.getRowNode(randomId);
  if (rowNode) {
    const randomCol = ["q1", "q2", "q3", "q4"][Math.floor(window.agRandom() * 4)];
    const newValue = Math.floor(window.agRandom() * 1000);
    console.log("onUpdateOneValue -> start");
    rowNode.setDataValue(randomCol, newValue);
    console.log("onUpdateOneValue -> end");
  }
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onExpireValueCache = onExpireValueCache;
  (<any>window).onRefreshCells = onRefreshCells;
  (<any>window).onUpdateOneValue = onUpdateOneValue;
}
```

[Live example: Expiring Cache through Editing](https://www.ag-grid.com/examples/value-cache/expiring-through-editing/typescript/)

> **Note**
>
> It is not possible to partially invalidate the Value Cache, eg it is not possible to invalidate only a portion of the cells. You might think that if you update a cell, then you only need to invalidate that row's data as the Value Getters can only access that row. That is not true - a Value Getter is a function where you can take data from anywhere in the grid and the grid is none the wiser. So if you change any value, then every single Value Getter is potentially impacted as far as the grid is concerned so the whole Value Cache is invalidated.

### Setting to Never Expire

Above details how the cache operates under normal operations. In essence, the Value Cache gets expired whenever the grid is aware of a change to the underlying data. This strategy is the default strategy for the Value Cache. If you want to **persist the cache** when data updates, then set the grid property `valueCacheNeverExpires=true`.

If you have `valueCacheNeverExpires=true`, then the only event that will expire the Value Cache will be the `api.expireValueCache()` method. Use this if your data is changing, but you don't want to execute Value Getters again, or you want to control exactly when the Value Cache is expired.

This example is again almost identical to the example above. The difference here is the Value Cache is turned on but to never invalidate. Note the following:

- When the grid initialises, there are 10 value getter calls. The values are getting cached.
- After you edit a cell, either through the UI or through the API by pressing **'Update One Value'**, the value getters are not called again, so the **Total** and **Total x 10** columns are not correctly refreshed. The grid already executed the value getters for this column, it will not do it again, it will instead take values from the value cache.
- To get the total column to update after edits, press **'Expire Value Cache'** (calls grid API `expireValueCache()`) and then press **'Aggregate Data & Refresh Cells'** (calls grid API `refreshClientSideRowModel('aggregate')` followed by grid API `refreshCells()`).

  The call `refreshClientSideRowModel('aggregate')` is required as aggregations use Value Getters, thus the aggregations at group level (that is the two total column at the two group rows) need aggregation to be re-run for their values to be updated.

  The call `refreshCells()` is required to update the UI, which in turn also calls Value Getters.

#### Never expire Value change

```ts
import {
  CellStyleModule,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  GetRowIdParams,
  GridApi,
  GridOptions,
  HighlightChangesModule,
  ModuleRegistry,
  NumberEditorModule,
  RenderApiModule,
  RowApiModule,
  TextEditorModule,
  ValueCacheModule,
  ValueFormatterParams,
  ValueGetterParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { getData } from "./data";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelApiModule,
  RowApiModule,
  RenderApiModule,
  NumberEditorModule,
  TextEditorModule,
  ValueCacheModule,
  HighlightChangesModule,
  CellStyleModule,
  ClientSideRowModelModule,
  RowGroupingModule,
]);

let callCount = 1;

const totalValueGetter = function (params: ValueGetterParams) {
  const q1 = params.getValue("q1");
  const q2 = params.getValue("q2");
  const q3 = params.getValue("q3");
  const q4 = params.getValue("q4");
  const result = q1 + q2 + q3 + q4;
  console.log(
    "Total Value Getter (" +
      callCount +
      ", " +
      params.column.getId() +
      "): " +
      [q1, q2, q3, q4].join(", ") +
      " = " +
      result,
  );
  callCount++;
  return result;
};
const total10ValueGetter = function (params: ValueGetterParams) {
  const total = params.getValue("total");
  return total * 10;
};
const columnDefs: ColDef[] = [
  { field: "q1", type: "quarterFigure" },
  { field: "q2", type: "quarterFigure" },
  { field: "q3", type: "quarterFigure" },
  { field: "q4", type: "quarterFigure" },
  { field: "year", rowGroup: true, hide: true },
  {
    headerName: "Total",
    colId: "total",
    cellClass: ["number-cell", "total-col"],
    aggFunc: "sum",
    valueFormatter: formatNumber,
    valueGetter: totalValueGetter,
  },
  {
    headerName: "Total x 10",
    cellClass: ["number-cell", "total-col"],
    aggFunc: "sum",
    minWidth: 120,
    valueFormatter: formatNumber,
    valueGetter: total10ValueGetter,
  },
];

let gridApi: GridApi;

const gridOptions: GridOptions = {
  columnDefs: columnDefs,
  defaultColDef: {
    flex: 1,
    enableCellChangeFlash: true,
  },
  autoGroupColumnDef: {
    minWidth: 130,
  },
  columnTypes: {
    quarterFigure: {
      editable: true,
      cellClass: "number-cell",
      aggFunc: "sum",
      valueFormatter: formatNumber,
      valueParser: function numberParser(params) {
        return Number(params.newValue);
      },
    },
  },
  valueCache: true,
  valueCacheNeverExpires: true,
  rowData: getData(),
  suppressAggFuncInHeader: true,
  groupDefaultExpanded: 1,
  getRowId: (params: GetRowIdParams) => {
    return String(params.data.id);
  },
  onCellValueChanged: () => {
    console.log("onCellValueChanged");
  },
};

function formatNumber(params: ValueFormatterParams) {
  const number = params.value;
  return Math.floor(number).toLocaleString();
}

function onExpireValueCache() {
  console.log("onInvalidateValueCache -> start");
  gridApi!.expireValueCache();
  console.log("onInvalidateValueCache -> end");
}

function onRefreshCells() {
  console.log("onRefreshCells -> start");
  gridApi!.refreshClientSideRowModel("aggregate");
  gridApi!.refreshCells();
  console.log("onRefreshCells -> end");
}

function onUpdateOneValue() {
  const randomId = Math.floor(window.agRandom() * 10) + "";
  const rowNode = gridApi!.getRowNode(randomId);
  if (rowNode) {
    const randomCol = ["q1", "q2", "q3", "q4"][Math.floor(window.agRandom() * 4)];
    const newValue = Math.floor(window.agRandom() * 1000);
    console.log("onUpdateOneValue -> start");
    rowNode.setDataValue(randomCol, newValue);
    console.log("onUpdateOneValue -> end");
  }
}

const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).onExpireValueCache = onExpireValueCache;
  (<any>window).onRefreshCells = onRefreshCells;
  (<any>window).onUpdateOneValue = onUpdateOneValue;
}
```

[Live example: Never expire Value change](https://www.ag-grid.com/examples/value-cache/never-expire/typescript/)


---
title: "Value Cache"
framework: react
version: "36.1.0"
---

# Value Cache

The Value Cache is for advanced users who have time-consuming Value Getters and want to reduce the number of times Value Getters get executed.

Each time the grid requires a value from a Value Getter, the Value Getter is executed. For most use cases, this will not be an issue, as Value Getters will execute quickly and not have any noticeable performance implications for your application. However sometimes you might implement time-intensive tasks in your Value Getters. If this is the case, then you can opt to turn on the Value Cache to store the results of the value getters.

If you are not using Value Getters, or you don't have performance problems, then you do not need the Value Cache.

When the Value Cache is turned on, each time a Value Getter is executed, its result is stored in the Value Cache. If the data in the grid has not changed since the last time the value getter was used, then the value is retrieved from the cache instead of executing the Value Getter again.

> **Note**
>
> One client of AG Grid had 1,000 rows and 20 columns in a grid. A lot of the columns were doing advanced maths, using third-party maths API in the valueGetter for 8 of the columns. The client was also grouping and the summing by the columns containing the value getters. This meant, if more rows were added, the grid recomputed the aggregations, resulting in all the value getters getting called again, causing the grid to stall for around 1,000ms as rows were added.
>
> Introducing the value cache meant the value getters were executed once when the initial data was loaded, so the 1,000ms happened once. Then when delta changes came in, the value getters were only executed on the new records, giving an almost seamless experience to the user.

Below shows a grid demonstrating the Value Cache. The column on the right has a Value Getter that has a `console.log()` statement. This will allow us to see exactly when the Value Getter is called. From the example, the following can be noted:

- When the grid is initially loaded, the **value getter is called over 100 times**. This is for the following reasons:
  - The aggregation requires each value for the group total.
  - The DOM requires each value that is displayed (because of scrolling, not all are displayed)
- As you **scroll up and down** the grid, the value getters are executed, as the DOM needs values for rendering.
- As you **open and close groups**, the value getters are executed, as the DOM needs values for rendering.
- Now turn the value cache **on** by selecting the radio button at the top. The grid gets reset and then works with the value cache on. Notice in the console that the value getter gets executed exactly 100 times, once for each row. Even through the value getter result is used in two places (aggregation and rendering the row), the value getter is only called once. Even scrolling and opening / closing the groups does not result in the value getter getting executed again.

#### Value Cache

```tsx
'use client';
import React, { StrictMode, useCallback, useMemo, useState } from "react";
import { createRoot } from "react-dom/client";

import type {
  ColDef,
  GetRowIdParams,
  ValueFormatterParams,
  ValueGetterParams,
} from "ag-grid-community";
import {
  CellStyleModule,
  ClientSideRowModelModule,
  HighlightChangesModule,
  ValueCacheModule,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { AgGridProvider, AgGridReact } from "ag-grid-react";

import { getData } from "./data";
import "./styles.css";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  ValueCacheModule,
  HighlightChangesModule,
  CellStyleModule,
  ClientSideRowModelModule,
  RowGroupingModule,
];

let callCount = 1;

function formatNumber(params: ValueFormatterParams) {
  return Math.floor(params.value).toLocaleString();
}

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);

  const [valueCacheOn, setValueCacheOn] = useState(false);
  const [gridKey, setGridKey] = useState("grid-key-off");

  const [rowData] = useState(getData());
  const [columnDefs] = useState<ColDef[]>([
    { field: "q1", type: "quarterFigure" },
    { field: "q2", type: "quarterFigure" },
    { field: "q3", type: "quarterFigure" },
    { field: "q4", type: "quarterFigure" },
    { field: "year", rowGroup: true, hide: true },
    {
      headerName: "Total",
      colId: "total",
      cellClass: ["number-cell", "total-col"],
      aggFunc: "sum",
      valueFormatter: formatNumber,
      valueGetter: (params: ValueGetterParams) => {
        const q1 = params.getValue("q1");
        const q2 = params.getValue("q2");
        const q3 = params.getValue("q3");
        const q4 = params.getValue("q4");
        const result = q1 + q2 + q3 + q4;
        console.log(
          `Total Value Getter (${callCount}, ${params.column.getId()}): ${[q1, q2, q3, q4].join(", ")} =  ${result}`,
        );
        callCount++;
        return result;
      },
    },
  ]);
  const defaultColDef = useMemo<ColDef>(
    () => ({ flex: 1, enableCellChangeFlash: true }),
    [],
  );
  const autoGroupColumnDef = useMemo<ColDef>(() => ({ minWidth: 140 }), []);
  const columnTypes = useMemo(
    () => ({
      quarterFigure: {
        cellClass: "number-cell",
        aggFunc: "sum",
        valueFormatter: formatNumber,
        valueParser: (params: { newValue: string }) => Number(params.newValue),
      },
    }),
    [],
  );
  const getRowId = useCallback(
    (params: GetRowIdParams) => String(params.data.id),
    [],
  );

  const onValueCache = useCallback((on: boolean) => {
    // valueCache is an initial-only grid option, so toggling it requires a full
    // grid re-creation — changing the key remounts the grid with the new setting.
    callCount = 1;
    setValueCacheOn(on);
    setGridKey(on ? "grid-key-on" : "grid-key-off");
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="example-wrapper">
          <div className="example-header">
            Value Cache:
            <input
              type="radio"
              id="valueCacheOn"
              name="valueCache"
              checked={valueCacheOn}
              onChange={() => onValueCache(true)}
            />
            <label htmlFor="valueCacheOn">On</label>
            <input
              type="radio"
              id="valueCacheOff"
              name="valueCache"
              checked={!valueCacheOn}
              onChange={() => onValueCache(false)}
            />
            <label htmlFor="valueCacheOff">Off</label>
          </div>
          <div style={gridStyle}>
            <AgGridReact
              key={gridKey}
              rowData={rowData}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
              autoGroupColumnDef={autoGroupColumnDef}
              columnTypes={columnTypes}
              valueCache={valueCacheOn}
              suppressAggFuncInHeader={true}
              groupDefaultExpanded={1}
              getRowId={getRowId}
              onCellValueChanged={() => console.log("onCellValueChanged")}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Value Cache](https://www.ag-grid.com/examples/value-cache/value-cache/reactFunctionalTs/)

> **Note**
>
> Note that the example still works fast when the Value Cache is turned off. This emphasises you don't need to turn the Value Cache on if your application is not getting slowed down by your Value Getters.

### Value Cache Properties

The following are the grid properties related to the Value Cache.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `valueCache` | `boolean` |  | `false` | Set to `true` to turn on the value cache. Module: [`ValueCacheModule`](https://www.ag-grid.com/react-data-grid/modules/). [Initial](https://www.ag-grid.com/react-data-grid/grid-interface/#initial-grid-options). |
| `valueCacheNeverExpires` | `boolean` |  | `false` | Set to `true` to configure the value cache to not expire after data updates. Module: [`ValueCacheModule`](https://www.ag-grid.com/react-data-grid/modules/). [Initial](https://www.ag-grid.com/react-data-grid/grid-interface/#initial-grid-options). |

### Expiring the Value Cache

The Value Cache starts empty. Then as Value Getters execute, their results are stored and the Value Cache fills up. Certain events trigger the Value Cache to be emptied. This is called expiring the Value Cache. Once expired, every Value Getter will get executed again next time the value is needed. The events that cause the Value Cache to expire are the following:

- New row data is set into the grid via `setGridOption('rowData', newData)` API or changing the `rowData` framework bound property*.
- New columns are set into the grid via `setGridOption('columnDefs', columnDefs)` API or changing the `columnDefs` framework bound property*.
- Data is modified using the `rowNode.setData(data)` or `rowNode.setDataValue(col,value)` node API methods.
- A value is modified in the grid using the grid's UI editing feature, e.g. the user double clicks a cell and enters a new value.
- The `expireValueCache()` grid API method gets called by the application.

> **Note**
>
> - Assuming your framework allows binding properties and this is what you are using.

The first example above didn't have any editing, so there was no concern for expiring the Value Cache. This example introduces grid editing. The example differs from the last in the following ways:

- Value Cache is on.
- Editing is enabled.
- There are only 10 rows, so it's easier to count the number of cells.
- There is another column **'Total x10'** which also uses a value getter and references the original **'Total'** column, thus calling this value getter results in an additional call to the original value getter.

As before, we focus on the Value Getter of the **'Total'** column and can see how many times it gets called via the console. The following can be noted:

- The values in the **Total** column are used many times as follows:
  - For inserting the value into the DOM (i.e. what's visible in the cell).
  - For calculating the group total for the total column (ie the figure 870,400 is a sum of the 5 values below it).
  - For calculating the **'Total x 10'** column, as that value getter also references the values in the **'Total'** column.
- Despite the values getting used multiple times, each value getter is executed exactly once. This can be observed observing the log message the value getter prints.
- If you close and then re-open a group, the value getters are not re-executed, even though the values are needed to re-create the DOM elements that represent the cells.
- Hitting **'Refresh Cells'** will refresh all the cells, but again the value getters will not get re-executed.
- Hitting **'Invalidate Cache'** and then **'Refresh Cells'** will result in the value getters getting re-executed, as the cell refresh operation requires the values and the cache was invalidated. You will notice invalidating and then refreshing doesn't do anything noticeable to the grid, the data is the same, the only hint that anything happened is the value getter's console messages.
- Changing any value in the grid, either editing via the UI directly or hitting the **'Update One Value'** button, will result in the value cache getting cleared and all cells getting refreshed (where [change detection](https://www.ag-grid.com/react-data-grid/change-detection/) then updates any changes cells and only changed cells).

#### Expiring Cache through Editing

```tsx
("use client");

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  AutoGroupColumnDef,
  CellStyleModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColTypeDefs,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  HighlightChangesModule,
  ModuleRegistry,
  NumberEditorModule,
  RenderApiModule,
  RowApiModule,
  TextEditorModule,
  ValueCacheModule,
  ValueFormatterParams,
  ValueGetterParams,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  RowApiModule,
  RenderApiModule,
  NumberEditorModule,
  TextEditorModule,
  ValueCacheModule,
  HighlightChangesModule,
  CellStyleModule,
  ClientSideRowModelModule,
  RowGroupingModule,
];

let callCount = 1;

const totalValueGetter = function (params: ValueGetterParams) {
  const q1 = params.getValue("q1");
  const q2 = params.getValue("q2");
  const q3 = params.getValue("q3");
  const q4 = params.getValue("q4");
  const result = q1 + q2 + q3 + q4;
  console.log(
    `Total Value Getter (${callCount}, ${params.column.getId()}): ${[q1, q2, q3, q4].join(", ")} = ${result}`,
  );
  callCount++;
  return result;
};

const total10ValueGetter = function (params: ValueGetterParams) {
  const total = params.getValue("total");
  return total * 10;
};

function formatNumber(params: ValueFormatterParams) {
  const number = params.value;
  return Math.floor(number).toLocaleString();
}

const GridExample = () => {
  const gridRef = useRef<AgGridReact>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(getData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "q1", type: "quarterFigure" },
    { field: "q2", type: "quarterFigure" },
    { field: "q3", type: "quarterFigure" },
    { field: "q4", type: "quarterFigure" },
    { field: "year", rowGroup: true, hide: true },
    {
      headerName: "Total",
      colId: "total",
      cellClass: ["number-cell", "total-col"],
      aggFunc: "sum",
      valueFormatter: formatNumber,
      valueGetter: totalValueGetter,
    },
    {
      headerName: "Total x 10",
      cellClass: ["number-cell", "total-col"],
      aggFunc: "sum",
      minWidth: 120,
      valueFormatter: formatNumber,
      valueGetter: total10ValueGetter,
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      enableCellChangeFlash: true,
    };
  }, []);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      minWidth: 130,
    };
  }, []);
  const columnTypes = useMemo<ColTypeDefs>(() => {
    return {
      quarterFigure: {
        editable: true,
        cellClass: "number-cell",
        aggFunc: "sum",
        valueFormatter: formatNumber,
        valueParser: function numberParser(params) {
          return Number(params.newValue);
        },
      },
    };
  }, []);
  const getRowId = useCallback((params: GetRowIdParams) => {
    return String(params.data.id);
  }, []);

  const onCellValueChanged = useCallback(() => {
    console.log("onCellValueChanged");
  }, []);

  const onExpireValueCache = useCallback(() => {
    console.log("onInvalidateValueCache -> start");
    gridRef.current!.api.expireValueCache();
    console.log("onInvalidateValueCache -> end");
  }, []);

  const onRefreshCells = useCallback(() => {
    console.log("onRefreshCells -> start");
    gridRef.current!.api.refreshCells();
    console.log("onRefreshCells -> end");
  }, []);

  const onUpdateOneValue = useCallback(() => {
    const randomId = Math.floor(window.agRandom() * 10) + "";
    const rowNode = gridRef.current!.api.getRowNode(randomId);
    if (rowNode) {
      const randomCol = ["q1", "q2", "q3", "q4"][Math.floor(window.agRandom() * 4)];
      const newValue = Math.floor(window.agRandom() * 1000);
      console.log("onUpdateOneValue -> start");
      rowNode.setDataValue(randomCol, newValue);
      console.log("onUpdateOneValue -> end");
    }
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div className="example-wrapper">
          <div style={{ marginBottom: "5px" }}>
            <button onClick={onExpireValueCache}>Invalidate Value Cache</button>
            <button onClick={onRefreshCells}>Refresh Cells</button>
            <button onClick={onUpdateOneValue}>Update One Value</button>
          </div>

          <div style={gridStyle}>
            <AgGridReact
              ref={gridRef}
              rowData={rowData}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
              autoGroupColumnDef={autoGroupColumnDef}
              columnTypes={columnTypes}
              suppressAggFuncInHeader={true}
              groupDefaultExpanded={1}
              valueCache={true}
              getRowId={getRowId}
              onCellValueChanged={onCellValueChanged}
            />
          </div>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Expiring Cache through Editing](https://www.ag-grid.com/examples/value-cache/expiring-through-editing/reactFunctionalTs/)

> **Note**
>
> It is not possible to partially invalidate the Value Cache, eg it is not possible to invalidate only a portion of the cells. You might think that if you update a cell, then you only need to invalidate that row's data as the Value Getters can only access that row. That is not true - a Value Getter is a function where you can take data from anywhere in the grid and the grid is none the wiser. So if you change any value, then every single Value Getter is potentially impacted as far as the grid is concerned so the whole Value Cache is invalidated.

### Setting to Never Expire

Above details how the cache operates under normal operations. In essence, the Value Cache gets expired whenever the grid is aware of a change to the underlying data. This strategy is the default strategy for the Value Cache. If you want to **persist the cache** when data updates, then set the grid property `valueCacheNeverExpires=true`.

If you have `valueCacheNeverExpires=true`, then the only event that will expire the Value Cache will be the `api.expireValueCache()` method. Use this if your data is changing, but you don't want to execute Value Getters again, or you want to control exactly when the Value Cache is expired.

This example is again almost identical to the example above. The difference here is the Value Cache is turned on but to never invalidate. Note the following:

- When the grid initialises, there are 10 value getter calls. The values are getting cached.
- After you edit a cell, either through the UI or through the API by pressing **'Update One Value'**, the value getters are not called again, so the **Total** and **Total x 10** columns are not correctly refreshed. The grid already executed the value getters for this column, it will not do it again, it will instead take values from the value cache.
- To get the total column to update after edits, press **'Expire Value Cache'** (calls grid API `expireValueCache()`) and then press **'Aggregate Data & Refresh Cells'** (calls grid API `refreshClientSideRowModel('aggregate')` followed by grid API `refreshCells()`).

  The call `refreshClientSideRowModel('aggregate')` is required as aggregations use Value Getters, thus the aggregations at group level (that is the two total column at the two group rows) need aggregation to be re-run for their values to be updated.

  The call `refreshCells()` is required to update the UI, which in turn also calls Value Getters.

#### Never expire Value change

```tsx
("use client");

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
  AutoGroupColumnDef,
  CellStyleModule,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColTypeDefs,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  HighlightChangesModule,
  ModuleRegistry,
  NumberEditorModule,
  RenderApiModule,
  RowApiModule,
  TextEditorModule,
  ValueCacheModule,
  ValueFormatterParams,
  ValueGetterParams,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

const modules = [
  ClientSideRowModelApiModule,
  RowApiModule,
  RenderApiModule,
  NumberEditorModule,
  TextEditorModule,
  ValueCacheModule,
  HighlightChangesModule,
  CellStyleModule,
  ClientSideRowModelModule,
  RowGroupingModule,
];

let callCount = 1;

const totalValueGetter = function (params: ValueGetterParams) {
  const q1 = params.getValue("q1");
  const q2 = params.getValue("q2");
  const q3 = params.getValue("q3");
  const q4 = params.getValue("q4");
  const result = q1 + q2 + q3 + q4;
  console.log(
    "Total Value Getter (" +
      callCount +
      ", " +
      params.column.getId() +
      "): " +
      [q1, q2, q3, q4].join(", ") +
      " = " +
      result,
  );
  callCount++;
  return result;
};

const total10ValueGetter = function (params: ValueGetterParams) {
  const total = params.getValue("total");
  return total * 10;
};

function formatNumber(params: ValueFormatterParams) {
  const number = params.value;
  return Math.floor(number).toLocaleString();
}

const GridExample = () => {
  const gridRef = useRef<AgGridReact>(null);
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(getData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    { field: "q1", type: "quarterFigure" },
    { field: "q2", type: "quarterFigure" },
    { field: "q3", type: "quarterFigure" },
    { field: "q4", type: "quarterFigure" },
    { field: "year", rowGroup: true, hide: true },
    {
      headerName: "Total",
      colId: "total",
      cellClass: ["number-cell", "total-col"],
      aggFunc: "sum",
      valueFormatter: formatNumber,
      valueGetter: totalValueGetter,
    },
    {
      headerName: "Total x 10",
      cellClass: ["number-cell", "total-col"],
      aggFunc: "sum",
      minWidth: 120,
      valueFormatter: formatNumber,
      valueGetter: total10ValueGetter,
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      enableCellChangeFlash: true,
    };
  }, []);
  const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
    return {
      minWidth: 130,
    };
  }, []);
  const columnTypes = useMemo<ColTypeDefs>(() => {
    return {
      quarterFigure: {
        editable: true,
        cellClass: "number-cell",
        aggFunc: "sum",
        valueFormatter: formatNumber,
        valueParser: function numberParser(params) {
          return Number(params.newValue);
        },
      },
    };
  }, []);
  const getRowId = useCallback((params: GetRowIdParams) => {
    return String(params.data.id);
  }, []);

  const onCellValueChanged = useCallback(() => {
    console.log("onCellValueChanged");
  }, []);

  const onExpireValueCache = useCallback(() => {
    console.log("onInvalidateValueCache -> start");
    gridRef.current!.api.expireValueCache();
    console.log("onInvalidateValueCache -> end");
  }, []);

  const onRefreshCells = useCallback(() => {
    console.log("onRefreshCells -> start");
    gridRef.current!.api.refreshClientSideRowModel("aggregate");
    gridRef.current!.api.refreshCells();
    console.log("onRefreshCells -> end");
  }, []);

  const onUpdateOneValue = useCallback(() => {
    const randomId = Math.floor(window.agRandom() * 10) + "";
    const rowNode = gridRef.current!.api.getRowNode(randomId);
    if (rowNode) {
      const randomCol = ["q1", "q2", "q3", "q4"][Math.floor(window.agRandom() * 4)];
      const newValue = Math.floor(window.agRandom() * 1000);
      console.log("onUpdateOneValue -> start");
      rowNode.setDataValue(randomCol, newValue);
      console.log("onUpdateOneValue -> end");
    }
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div
          style={{
            height: "100%",
            boxSizing: "border-box",
            paddingTop: "45px",
          }}
        >
          <div style={gridStyle}>
            <AgGridReact
              ref={gridRef}
              rowData={rowData}
              columnDefs={columnDefs}
              defaultColDef={defaultColDef}
              autoGroupColumnDef={autoGroupColumnDef}
              columnTypes={columnTypes}
              valueCache={true}
              valueCacheNeverExpires={true}
              suppressAggFuncInHeader={true}
              groupDefaultExpanded={1}
              getRowId={getRowId}
              onCellValueChanged={onCellValueChanged}
            />
          </div>
        </div>
        <div style={{ position: "absolute", top: "0", left: "15px" }}>
          <button onClick={onUpdateOneValue}>Update One Value</button>
          <button onClick={onExpireValueCache}>Expire Value Cache</button>
          <button onClick={onRefreshCells}>
            Aggregate Data &amp; Refresh Cells
          </button>
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Never expire Value change](https://www.ag-grid.com/examples/value-cache/never-expire/reactFunctionalTs/)


---
title: "Value Cache"
framework: angular
version: "36.1.0"
---

# Value Cache

The Value Cache is for advanced users who have time-consuming Value Getters and want to reduce the number of times Value Getters get executed.

Each time the grid requires a value from a Value Getter, the Value Getter is executed. For most use cases, this will not be an issue, as Value Getters will execute quickly and not have any noticeable performance implications for your application. However sometimes you might implement time-intensive tasks in your Value Getters. If this is the case, then you can opt to turn on the Value Cache to store the results of the value getters.

If you are not using Value Getters, or you don't have performance problems, then you do not need the Value Cache.

When the Value Cache is turned on, each time a Value Getter is executed, its result is stored in the Value Cache. If the data in the grid has not changed since the last time the value getter was used, then the value is retrieved from the cache instead of executing the Value Getter again.

> **Note**
>
> One client of AG Grid had 1,000 rows and 20 columns in a grid. A lot of the columns were doing advanced maths, using third-party maths API in the valueGetter for 8 of the columns. The client was also grouping and the summing by the columns containing the value getters. This meant, if more rows were added, the grid recomputed the aggregations, resulting in all the value getters getting called again, causing the grid to stall for around 1,000ms as rows were added.
>
> Introducing the value cache meant the value getters were executed once when the initial data was loaded, so the 1,000ms happened once. Then when delta changes came in, the value getters were only executed on the new records, giving an almost seamless experience to the user.

Below shows a grid demonstrating the Value Cache. The column on the right has a Value Getter that has a `console.log()` statement. This will allow us to see exactly when the Value Getter is called. From the example, the following can be noted:

- When the grid is initially loaded, the **value getter is called over 100 times**. This is for the following reasons:
  - The aggregation requires each value for the group total.
  - The DOM requires each value that is displayed (because of scrolling, not all are displayed)
- As you **scroll up and down** the grid, the value getters are executed, as the DOM needs values for rendering.
- As you **open and close groups**, the value getters are executed, as the DOM needs values for rendering.
- Now turn the value cache **on** by selecting the radio button at the top. The grid gets reset and then works with the value cache on. Notice in the console that the value getter gets executed exactly 100 times, once for each row. Even through the value getter result is used in two places (aggregation and rendering the row), the value getter is only called once. Even scrolling and opening / closing the groups does not result in the value getter getting executed again.

#### Value Cache

```ts
import { Component } from "@angular/core";

import { AgGridAngular } from "ag-grid-angular";
import type {
  ColDef,
  GetRowIdParams,
  ValueFormatterParams,
  ValueGetterParams,
} from "ag-grid-community";
import {
  CellStyleModule,
  ClientSideRowModelModule,
  HighlightChangesModule,
  ModuleRegistry,
  ValueCacheModule,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";

import { getData } from "./data";
import "./styles.css";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ValueCacheModule,
  HighlightChangesModule,
  CellStyleModule,
  ClientSideRowModelModule,
  RowGroupingModule,
]);

let callCount = 1;

function formatNumber(params: ValueFormatterParams) {
  return Math.floor(params.value).toLocaleString();
}

@Component({
  standalone: true,
  imports: [AgGridAngular],
  selector: "my-app",
  template: `
    <div class="example-wrapper">
      <div class="example-header">
        Value Cache:
        <input
          type="radio"
          id="valueCacheOn"
          name="valueCache"
          [checked]="valueCacheOn"
          (change)="onValueCache(true)"
        /><label for="valueCacheOn">On</label>
        <input
          type="radio"
          id="valueCacheOff"
          name="valueCache"
          [checked]="!valueCacheOn"
          (change)="onValueCache(false)"
        /><label for="valueCacheOff">Off</label>
      </div>
      @if (isVisible) {
        <ag-grid-angular
          style="width: 100%; height: 100%;"
          [columnDefs]="columnDefs"
          [defaultColDef]="defaultColDef"
          [autoGroupColumnDef]="autoGroupColumnDef"
          [columnTypes]="columnTypes"
          [rowData]="rowData"
          [valueCache]="valueCacheOn"
          [suppressAggFuncInHeader]="true"
          [groupDefaultExpanded]="1"
          [getRowId]="getRowId"
          (cellValueChanged)="onCellValueChanged()"
        />
      }
    </div>
  `,
})
export class AppComponent {
  public valueCacheOn = false;
  public isVisible = true;

  public columnDefs: ColDef[] = [
    { field: "q1", type: "quarterFigure" },
    { field: "q2", type: "quarterFigure" },
    { field: "q3", type: "quarterFigure" },
    { field: "q4", type: "quarterFigure" },
    { field: "year", rowGroup: true, hide: true },
    {
      headerName: "Total",
      colId: "total",
      cellClass: ["number-cell", "total-col"],
      aggFunc: "sum",
      valueFormatter: formatNumber,
      valueGetter: (params: ValueGetterParams) => {
        const q1 = params.getValue("q1");
        const q2 = params.getValue("q2");
        const q3 = params.getValue("q3");
        const q4 = params.getValue("q4");
        const result = q1 + q2 + q3 + q4;
        console.log(
          `Total Value Getter (${callCount}, ${params.column.getId()}): ${[q1, q2, q3, q4].join(", ")} =  ${result}`,
        );
        callCount++;
        return result;
      },
    },
  ];
  public defaultColDef: ColDef = { flex: 1, enableCellChangeFlash: true };
  public autoGroupColumnDef: ColDef = { minWidth: 140 };
  public columnTypes = {
    quarterFigure: {
      cellClass: "number-cell",
      aggFunc: "sum",
      valueFormatter: formatNumber,
      valueParser: (params: { newValue: string }) => Number(params.newValue),
    },
  };
  public rowData: any[] = getData();
  public getRowId = (params: GetRowIdParams) => String(params.data.id);

  onValueCache(on: boolean) {
    // valueCache is an initial-only grid option, so toggling it requires a full
    // grid re-creation — remove then re-add the grid to pick up the new setting.
    callCount = 1;
    this.valueCacheOn = on;
    this.isVisible = false;
    setTimeout(() => (this.isVisible = true), 1);
  }

  onCellValueChanged() {
    console.log("onCellValueChanged");
  }
}
```

[Live example: Value Cache](https://www.ag-grid.com/examples/value-cache/value-cache/angular)

> **Note**
>
> Note that the example still works fast when the Value Cache is turned off. This emphasises you don't need to turn the Value Cache on if your application is not getting slowed down by your Value Getters.

### Value Cache Properties

The following are the grid properties related to the Value Cache.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `valueCache` | `boolean` |  | `false` | Set to `true` to turn on the value cache. Module: [`ValueCacheModule`](https://www.ag-grid.com/angular-data-grid/modules/). [Initial](https://www.ag-grid.com/angular-data-grid/grid-interface/#initial-grid-options). |
| `valueCacheNeverExpires` | `boolean` |  | `false` | Set to `true` to configure the value cache to not expire after data updates. Module: [`ValueCacheModule`](https://www.ag-grid.com/angular-data-grid/modules/). [Initial](https://www.ag-grid.com/angular-data-grid/grid-interface/#initial-grid-options). |

### Expiring the Value Cache

The Value Cache starts empty. Then as Value Getters execute, their results are stored and the Value Cache fills up. Certain events trigger the Value Cache to be emptied. This is called expiring the Value Cache. Once expired, every Value Getter will get executed again next time the value is needed. The events that cause the Value Cache to expire are the following:

- New row data is set into the grid via `setGridOption('rowData', newData)` API or changing the `rowData` framework bound property*.
- New columns are set into the grid via `setGridOption('columnDefs', columnDefs)` API or changing the `columnDefs` framework bound property*.
- Data is modified using the `rowNode.setData(data)` or `rowNode.setDataValue(col,value)` node API methods.
- A value is modified in the grid using the grid's UI editing feature, e.g. the user double clicks a cell and enters a new value.
- The `expireValueCache()` grid API method gets called by the application.

> **Note**
>
> - Assuming your framework allows binding properties and this is what you are using.

The first example above didn't have any editing, so there was no concern for expiring the Value Cache. This example introduces grid editing. The example differs from the last in the following ways:

- Value Cache is on.
- Editing is enabled.
- There are only 10 rows, so it's easier to count the number of cells.
- There is another column **'Total x10'** which also uses a value getter and references the original **'Total'** column, thus calling this value getter results in an additional call to the original value getter.

As before, we focus on the Value Getter of the **'Total'** column and can see how many times it gets called via the console. The following can be noted:

- The values in the **Total** column are used many times as follows:
  - For inserting the value into the DOM (i.e. what's visible in the cell).
  - For calculating the group total for the total column (ie the figure 870,400 is a sum of the 5 values below it).
  - For calculating the **'Total x 10'** column, as that value getter also references the values in the **'Total'** column.
- Despite the values getting used multiple times, each value getter is executed exactly once. This can be observed observing the log message the value getter prints.
- If you close and then re-open a group, the value getters are not re-executed, even though the values are needed to re-create the DOM elements that represent the cells.
- Hitting **'Refresh Cells'** will refresh all the cells, but again the value getters will not get re-executed.
- Hitting **'Invalidate Cache'** and then **'Refresh Cells'** will result in the value getters getting re-executed, as the cell refresh operation requires the values and the cache was invalidated. You will notice invalidating and then refreshing doesn't do anything noticeable to the grid, the data is the same, the only hint that anything happened is the value getter's console messages.
- Changing any value in the grid, either editing via the UI directly or hitting the **'Update One Value'** button, will result in the value cache getting cleared and all cells getting refreshed (where [change detection](https://www.ag-grid.com/angular-data-grid/change-detection/) then updates any changes cells and only changed cells).

#### Expiring Cache through Editing

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  AutoGroupColumnDef,
  CellStyleModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColTypeDefs,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  HighlightChangesModule,
  ModuleRegistry,
  NumberEditorModule,
  RenderApiModule,
  RowApiModule,
  TextEditorModule,
  ValueCacheModule,
  ValueFormatterParams,
  ValueGetterParams,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowApiModule,
  RenderApiModule,
  NumberEditorModule,
  TextEditorModule,
  ValueCacheModule,
  HighlightChangesModule,
  CellStyleModule,
  ClientSideRowModelModule,
  RowGroupingModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div class="example-wrapper">
    <div style="margin-bottom: 5px">
      <button (click)="onExpireValueCache()">Invalidate Value Cache</button>
      <button (click)="onRefreshCells()">Refresh Cells</button>
      <button (click)="onUpdateOneValue()">Update One Value</button>
    </div>

    <ag-grid-angular
      style="width: 100%; height: 100%;"
      [columnDefs]="columnDefs"
      [defaultColDef]="defaultColDef"
      [autoGroupColumnDef]="autoGroupColumnDef"
      [columnTypes]="columnTypes"
      [rowData]="rowData"
      [suppressAggFuncInHeader]="true"
      [groupDefaultExpanded]="groupDefaultExpanded"
      [valueCache]="true"
      [getRowId]="getRowId"
      (cellValueChanged)="onCellValueChanged($event)"
      (gridReady)="onGridReady($event)"
    />
  </div> `,
})
export class AppComponent {
  private gridApi!: GridApi;

  columnDefs: ColDef[] = [
    { field: "q1", type: "quarterFigure" },
    { field: "q2", type: "quarterFigure" },
    { field: "q3", type: "quarterFigure" },
    { field: "q4", type: "quarterFigure" },
    { field: "year", rowGroup: true, hide: true },
    {
      headerName: "Total",
      colId: "total",
      cellClass: ["number-cell", "total-col"],
      aggFunc: "sum",
      valueFormatter: formatNumber,
      valueGetter: totalValueGetter,
    },
    {
      headerName: "Total x 10",
      cellClass: ["number-cell", "total-col"],
      aggFunc: "sum",
      minWidth: 120,
      valueFormatter: formatNumber,
      valueGetter: total10ValueGetter,
    },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    enableCellChangeFlash: true,
  };
  autoGroupColumnDef: AutoGroupColumnDef = {
    minWidth: 130,
  };
  columnTypes: ColTypeDefs = {
    quarterFigure: {
      editable: true,
      cellClass: "number-cell",
      aggFunc: "sum",
      valueFormatter: formatNumber,
      valueParser: function numberParser(params) {
        return Number(params.newValue);
      },
    },
  };
  rowData: any[] | null = getData();
  groupDefaultExpanded = 1;
  getRowId: GetRowIdFunc = (params: GetRowIdParams) => {
    return String(params.data.id);
  };

  onCellValueChanged() {
    console.log("onCellValueChanged");
  }

  onExpireValueCache() {
    console.log("onInvalidateValueCache -> start");
    this.gridApi.expireValueCache();
    console.log("onInvalidateValueCache -> end");
  }

  onRefreshCells() {
    console.log("onRefreshCells -> start");
    this.gridApi.refreshCells();
    console.log("onRefreshCells -> end");
  }

  onUpdateOneValue() {
    const randomId = Math.floor(window.agRandom() * 10) + "";
    const rowNode = this.gridApi.getRowNode(randomId);
    if (rowNode) {
      const randomCol = ["q1", "q2", "q3", "q4"][Math.floor(window.agRandom() * 4)];
      const newValue = Math.floor(window.agRandom() * 1000);
      console.log("onUpdateOneValue -> start");
      rowNode.setDataValue(randomCol, newValue);
      console.log("onUpdateOneValue -> end");
    }
  }

  onGridReady(params: GridReadyEvent) {
    this.gridApi = params.api;
  }
}

let callCount = 1;
const totalValueGetter = function (params: ValueGetterParams) {
  const q1 = params.getValue("q1");
  const q2 = params.getValue("q2");
  const q3 = params.getValue("q3");
  const q4 = params.getValue("q4");
  const result = q1 + q2 + q3 + q4;
  console.log(
    `Total Value Getter (${callCount}, ${params.column.getId()}): ${[q1, q2, q3, q4].join(", ")} = ${result}`,
  );
  callCount++;
  return result;
};
const total10ValueGetter = function (params: ValueGetterParams) {
  const total = params.getValue("total");
  return total * 10;
};
function formatNumber(params: ValueFormatterParams) {
  const number = params.value;
  return Math.floor(number).toLocaleString();
}
```

[Live example: Expiring Cache through Editing](https://www.ag-grid.com/examples/value-cache/expiring-through-editing/angular)

> **Note**
>
> It is not possible to partially invalidate the Value Cache, eg it is not possible to invalidate only a portion of the cells. You might think that if you update a cell, then you only need to invalidate that row's data as the Value Getters can only access that row. That is not true - a Value Getter is a function where you can take data from anywhere in the grid and the grid is none the wiser. So if you change any value, then every single Value Getter is potentially impacted as far as the grid is concerned so the whole Value Cache is invalidated.

### Setting to Never Expire

Above details how the cache operates under normal operations. In essence, the Value Cache gets expired whenever the grid is aware of a change to the underlying data. This strategy is the default strategy for the Value Cache. If you want to **persist the cache** when data updates, then set the grid property `valueCacheNeverExpires=true`.

If you have `valueCacheNeverExpires=true`, then the only event that will expire the Value Cache will be the `api.expireValueCache()` method. Use this if your data is changing, but you don't want to execute Value Getters again, or you want to control exactly when the Value Cache is expired.

This example is again almost identical to the example above. The difference here is the Value Cache is turned on but to never invalidate. Note the following:

- When the grid initialises, there are 10 value getter calls. The values are getting cached.
- After you edit a cell, either through the UI or through the API by pressing **'Update One Value'**, the value getters are not called again, so the **Total** and **Total x 10** columns are not correctly refreshed. The grid already executed the value getters for this column, it will not do it again, it will instead take values from the value cache.
- To get the total column to update after edits, press **'Expire Value Cache'** (calls grid API `expireValueCache()`) and then press **'Aggregate Data & Refresh Cells'** (calls grid API `refreshClientSideRowModel('aggregate')` followed by grid API `refreshCells()`).

  The call `refreshClientSideRowModel('aggregate')` is required as aggregations use Value Getters, thus the aggregations at group level (that is the two total column at the two group rows) need aggregation to be re-run for their values to be updated.

  The call `refreshCells()` is required to update the UI, which in turn also calls Value Getters.

#### Never expire Value change

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
  AutoGroupColumnDef,
  CellStyleModule,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColTypeDefs,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  HighlightChangesModule,
  ModuleRegistry,
  NumberEditorModule,
  RenderApiModule,
  RowApiModule,
  TextEditorModule,
  ValueCacheModule,
  ValueFormatterParams,
  ValueGetterParams,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelApiModule,
  RowApiModule,
  RenderApiModule,
  NumberEditorModule,
  TextEditorModule,
  ValueCacheModule,
  HighlightChangesModule,
  CellStyleModule,
  ClientSideRowModelModule,
  RowGroupingModule,
]);

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular],
  template: `<div
      style="height: 100%; box-sizing: border-box; padding-top: 45px"
    >
      <ag-grid-angular
        style="width: 100%; height: 100%;"
        [columnDefs]="columnDefs"
        [defaultColDef]="defaultColDef"
        [autoGroupColumnDef]="autoGroupColumnDef"
        [columnTypes]="columnTypes"
        [valueCache]="true"
        [valueCacheNeverExpires]="true"
        [rowData]="rowData"
        [suppressAggFuncInHeader]="true"
        [groupDefaultExpanded]="groupDefaultExpanded"
        [getRowId]="getRowId"
        (cellValueChanged)="onCellValueChanged($event)"
        (gridReady)="onGridReady($event)"
      />
    </div>
    <div style="position: absolute; top: 0; left: 15px">
      <button (click)="onUpdateOneValue()">Update One Value</button>
      <button (click)="onExpireValueCache()">Expire Value Cache</button>
      <button (click)="onRefreshCells()">
        Aggregate Data &amp; Refresh Cells
      </button>
    </div> `,
})
export class AppComponent {
  private gridApi!: GridApi;

  columnDefs: ColDef[] = [
    { field: "q1", type: "quarterFigure" },
    { field: "q2", type: "quarterFigure" },
    { field: "q3", type: "quarterFigure" },
    { field: "q4", type: "quarterFigure" },
    { field: "year", rowGroup: true, hide: true },
    {
      headerName: "Total",
      colId: "total",
      cellClass: ["number-cell", "total-col"],
      aggFunc: "sum",
      valueFormatter: formatNumber,
      valueGetter: totalValueGetter,
    },
    {
      headerName: "Total x 10",
      cellClass: ["number-cell", "total-col"],
      aggFunc: "sum",
      minWidth: 120,
      valueFormatter: formatNumber,
      valueGetter: total10ValueGetter,
    },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    enableCellChangeFlash: true,
  };
  autoGroupColumnDef: AutoGroupColumnDef = {
    minWidth: 130,
  };
  columnTypes: ColTypeDefs = {
    quarterFigure: {
      editable: true,
      cellClass: "number-cell",
      aggFunc: "sum",
      valueFormatter: formatNumber,
      valueParser: function numberParser(params) {
        return Number(params.newValue);
      },
    },
  };
  rowData: any[] | null = getData();
  groupDefaultExpanded = 1;
  getRowId: GetRowIdFunc = (params: GetRowIdParams) => {
    return String(params.data.id);
  };

  onCellValueChanged() {
    console.log("onCellValueChanged");
  }

  onExpireValueCache() {
    console.log("onInvalidateValueCache -> start");
    this.gridApi.expireValueCache();
    console.log("onInvalidateValueCache -> end");
  }

  onRefreshCells() {
    console.log("onRefreshCells -> start");
    this.gridApi.refreshClientSideRowModel("aggregate");
    this.gridApi.refreshCells();
    console.log("onRefreshCells -> end");
  }

  onUpdateOneValue() {
    const randomId = Math.floor(window.agRandom() * 10) + "";
    const rowNode = this.gridApi.getRowNode(randomId);
    if (rowNode) {
      const randomCol = ["q1", "q2", "q3", "q4"][Math.floor(window.agRandom() * 4)];
      const newValue = Math.floor(window.agRandom() * 1000);
      console.log("onUpdateOneValue -> start");
      rowNode.setDataValue(randomCol, newValue);
      console.log("onUpdateOneValue -> end");
    }
  }

  onGridReady(params: GridReadyEvent) {
    this.gridApi = params.api;
  }
}

let callCount = 1;
const totalValueGetter = function (params: ValueGetterParams) {
  const q1 = params.getValue("q1");
  const q2 = params.getValue("q2");
  const q3 = params.getValue("q3");
  const q4 = params.getValue("q4");
  const result = q1 + q2 + q3 + q4;
  console.log(
    "Total Value Getter (" +
      callCount +
      ", " +
      params.column.getId() +
      "): " +
      [q1, q2, q3, q4].join(", ") +
      " = " +
      result,
  );
  callCount++;
  return result;
};
const total10ValueGetter = function (params: ValueGetterParams) {
  const total = params.getValue("total");
  return total * 10;
};
function formatNumber(params: ValueFormatterParams) {
  const number = params.value;
  return Math.floor(number).toLocaleString();
}
```

[Live example: Never expire Value change](https://www.ag-grid.com/examples/value-cache/never-expire/angular)


---
title: "Value Cache"
framework: vue
version: "36.1.0"
---

# Value Cache

The Value Cache is for advanced users who have time-consuming Value Getters and want to reduce the number of times Value Getters get executed.

Each time the grid requires a value from a Value Getter, the Value Getter is executed. For most use cases, this will not be an issue, as Value Getters will execute quickly and not have any noticeable performance implications for your application. However sometimes you might implement time-intensive tasks in your Value Getters. If this is the case, then you can opt to turn on the Value Cache to store the results of the value getters.

If you are not using Value Getters, or you don't have performance problems, then you do not need the Value Cache.

When the Value Cache is turned on, each time a Value Getter is executed, its result is stored in the Value Cache. If the data in the grid has not changed since the last time the value getter was used, then the value is retrieved from the cache instead of executing the Value Getter again.

> **Note**
>
> One client of AG Grid had 1,000 rows and 20 columns in a grid. A lot of the columns were doing advanced maths, using third-party maths API in the valueGetter for 8 of the columns. The client was also grouping and the summing by the columns containing the value getters. This meant, if more rows were added, the grid recomputed the aggregations, resulting in all the value getters getting called again, causing the grid to stall for around 1,000ms as rows were added.
>
> Introducing the value cache meant the value getters were executed once when the initial data was loaded, so the 1,000ms happened once. Then when delta changes came in, the value getters were only executed on the new records, giving an almost seamless experience to the user.

Below shows a grid demonstrating the Value Cache. The column on the right has a Value Getter that has a `console.log()` statement. This will allow us to see exactly when the Value Getter is called. From the example, the following can be noted:

- When the grid is initially loaded, the **value getter is called over 100 times**. This is for the following reasons:
  - The aggregation requires each value for the group total.
  - The DOM requires each value that is displayed (because of scrolling, not all are displayed)
- As you **scroll up and down** the grid, the value getters are executed, as the DOM needs values for rendering.
- As you **open and close groups**, the value getters are executed, as the DOM needs values for rendering.
- Now turn the value cache **on** by selecting the radio button at the top. The grid gets reset and then works with the value cache on. Notice in the console that the value getter gets executed exactly 100 times, once for each row. Even through the value getter result is used in two places (aggregation and rendering the row), the value getter is only called once. Even scrolling and opening / closing the groups does not result in the value getter getting executed again.

#### Value Cache

```ts
import { createApp, defineComponent, ref } from "vue";

import type {
  ColDef,
  GetRowIdParams,
  ValueFormatterParams,
  ValueGetterParams,
} from "ag-grid-community";
import {
  CellStyleModule,
  ClientSideRowModelModule,
  HighlightChangesModule,
  ModuleRegistry,
  ValueCacheModule,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { AgGridVue } from "ag-grid-vue3";

import { getData } from "./data";
import "./styles.css";

// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ValueCacheModule,
  HighlightChangesModule,
  CellStyleModule,
  ClientSideRowModelModule,
  RowGroupingModule,
]);

let callCount = 1;

function formatNumber(params: ValueFormatterParams) {
  return Math.floor(params.value).toLocaleString();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
            <div class="example-wrapper">
                <div class="example-header">
                    Value Cache:
                    <input type="radio" id="valueCacheOn" name="valueCache" :checked="valueCacheOn" @change="onValueCache(true)"><label for="valueCacheOn">On</label>
                    <input type="radio" id="valueCacheOff" name="valueCache" :checked="!valueCacheOn" @change="onValueCache(false)"><label for="valueCacheOff">Off</label>
                </div>
                <ag-grid-vue
                    v-if="isVisible"
                    style="width: 100%; height: 100%;"
                    :columnDefs="columnDefs"
                    :defaultColDef="defaultColDef"
                    :autoGroupColumnDef="autoGroupColumnDef"
                    :columnTypes="columnTypes"
                    :rowData="rowData"
                    :valueCache="valueCacheOn"
                    :suppressAggFuncInHeader="true"
                    :groupDefaultExpanded="1"
                    :getRowId="getRowId"
                    @cell-value-changed="onCellValueChanged"></ag-grid-vue>
            </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup() {
    const columnDefs = ref<ColDef[]>([
      { field: "q1", type: "quarterFigure" },
      { field: "q2", type: "quarterFigure" },
      { field: "q3", type: "quarterFigure" },
      { field: "q4", type: "quarterFigure" },
      { field: "year", rowGroup: true, hide: true },
      {
        headerName: "Total",
        colId: "total",
        cellClass: ["number-cell", "total-col"],
        aggFunc: "sum",
        valueFormatter: formatNumber,
        valueGetter: (params: ValueGetterParams) => {
          const q1 = params.getValue("q1");
          const q2 = params.getValue("q2");
          const q3 = params.getValue("q3");
          const q4 = params.getValue("q4");
          const result = q1 + q2 + q3 + q4;
          console.log(
            `Total Value Getter (${callCount}, ${params.column.getId()}): ${[q1, q2, q3, q4].join(", ")} =  ${result}`,
          );
          callCount++;
          return result;
        },
      },
    ]);
    const defaultColDef = ref<ColDef>({ flex: 1, enableCellChangeFlash: true });
    const autoGroupColumnDef = ref<ColDef>({ minWidth: 140 });
    const columnTypes = ref({
      quarterFigure: {
        cellClass: "number-cell",
        aggFunc: "sum",
        valueFormatter: formatNumber,
        valueParser: (params: { newValue: string }) => Number(params.newValue),
      },
    });
    const rowData = ref<any[]>(getData());
    const getRowId = (params: GetRowIdParams) => String(params.data.id);

    const valueCacheOn = ref(false);
    const isVisible = ref(true);

    const onValueCache = (on: boolean) => {
      // valueCache is an initial-only grid option, so toggling it requires a full
      // grid re-creation — remove then re-add the grid to pick up the new setting.
      callCount = 1;
      valueCacheOn.value = on;
      isVisible.value = false;
      setTimeout(() => (isVisible.value = true), 1);
    };

    const onCellValueChanged = () => {
      console.log("onCellValueChanged");
    };

    return {
      columnDefs,
      defaultColDef,
      autoGroupColumnDef,
      columnTypes,
      rowData,
      getRowId,
      valueCacheOn,
      isVisible,
      onValueCache,
      onCellValueChanged,
    };
  },
});

createApp(VueExample).mount("#app");
```

[Live example: Value Cache](https://www.ag-grid.com/examples/value-cache/value-cache/vue3)

> **Note**
>
> Note that the example still works fast when the Value Cache is turned off. This emphasises you don't need to turn the Value Cache on if your application is not getting slowed down by your Value Getters.

### Value Cache Properties

The following are the grid properties related to the Value Cache.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `valueCache` | `boolean` |  | `false` | Set to `true` to turn on the value cache. Module: [`ValueCacheModule`](https://www.ag-grid.com/vue-data-grid/modules/). [Initial](https://www.ag-grid.com/vue-data-grid/grid-interface/#initial-grid-options). |
| `valueCacheNeverExpires` | `boolean` |  | `false` | Set to `true` to configure the value cache to not expire after data updates. Module: [`ValueCacheModule`](https://www.ag-grid.com/vue-data-grid/modules/). [Initial](https://www.ag-grid.com/vue-data-grid/grid-interface/#initial-grid-options). |

### Expiring the Value Cache

The Value Cache starts empty. Then as Value Getters execute, their results are stored and the Value Cache fills up. Certain events trigger the Value Cache to be emptied. This is called expiring the Value Cache. Once expired, every Value Getter will get executed again next time the value is needed. The events that cause the Value Cache to expire are the following:

- New row data is set into the grid via `setGridOption('rowData', newData)` API or changing the `rowData` framework bound property*.
- New columns are set into the grid via `setGridOption('columnDefs', columnDefs)` API or changing the `columnDefs` framework bound property*.
- Data is modified using the `rowNode.setData(data)` or `rowNode.setDataValue(col,value)` node API methods.
- A value is modified in the grid using the grid's UI editing feature, e.g. the user double clicks a cell and enters a new value.
- The `expireValueCache()` grid API method gets called by the application.

> **Note**
>
> - Assuming your framework allows binding properties and this is what you are using.

The first example above didn't have any editing, so there was no concern for expiring the Value Cache. This example introduces grid editing. The example differs from the last in the following ways:

- Value Cache is on.
- Editing is enabled.
- There are only 10 rows, so it's easier to count the number of cells.
- There is another column **'Total x10'** which also uses a value getter and references the original **'Total'** column, thus calling this value getter results in an additional call to the original value getter.

As before, we focus on the Value Getter of the **'Total'** column and can see how many times it gets called via the console. The following can be noted:

- The values in the **Total** column are used many times as follows:
  - For inserting the value into the DOM (i.e. what's visible in the cell).
  - For calculating the group total for the total column (ie the figure 870,400 is a sum of the 5 values below it).
  - For calculating the **'Total x 10'** column, as that value getter also references the values in the **'Total'** column.
- Despite the values getting used multiple times, each value getter is executed exactly once. This can be observed observing the log message the value getter prints.
- If you close and then re-open a group, the value getters are not re-executed, even though the values are needed to re-create the DOM elements that represent the cells.
- Hitting **'Refresh Cells'** will refresh all the cells, but again the value getters will not get re-executed.
- Hitting **'Invalidate Cache'** and then **'Refresh Cells'** will result in the value getters getting re-executed, as the cell refresh operation requires the values and the cache was invalidated. You will notice invalidating and then refreshing doesn't do anything noticeable to the grid, the data is the same, the only hint that anything happened is the value getter's console messages.
- Changing any value in the grid, either editing via the UI directly or hitting the **'Update One Value'** button, will result in the value cache getting cleared and all cells getting refreshed (where [change detection](https://www.ag-grid.com/vue-data-grid/change-detection/) then updates any changes cells and only changed cells).

#### Expiring Cache through Editing

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  AutoGroupColumnDef,
  CellStyleModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColTypeDefs,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  HighlightChangesModule,
  ModuleRegistry,
  NumberEditorModule,
  RenderApiModule,
  RowApiModule,
  TextEditorModule,
  ValueCacheModule,
  ValueFormatterParams,
  ValueGetterParams,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  RowApiModule,
  RenderApiModule,
  NumberEditorModule,
  TextEditorModule,
  ValueCacheModule,
  HighlightChangesModule,
  CellStyleModule,
  ClientSideRowModelModule,
  RowGroupingModule,
]);

let callCount = 1;

const totalValueGetter = function (params: ValueGetterParams) {
  const q1 = params.getValue("q1");
  const q2 = params.getValue("q2");
  const q3 = params.getValue("q3");
  const q4 = params.getValue("q4");
  const result = q1 + q2 + q3 + q4;
  console.log(
    `Total Value Getter (${callCount}, ${params.column.getId()}): ${[q1, q2, q3, q4].join(", ")} = ${result}`,
  );
  callCount++;
  return result;
};

const total10ValueGetter = function (params: ValueGetterParams) {
  const total = params.getValue("total");
  return total * 10;
};

function formatNumber(params: ValueFormatterParams) {
  const number = params.value;
  return Math.floor(number).toLocaleString();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div class="example-wrapper">
      <div style="margin-bottom: 5px">
        <button v-on:click="onExpireValueCache()">Invalidate Value Cache</button>
        <button v-on:click="onRefreshCells()">Refresh Cells</button>
        <button v-on:click="onUpdateOneValue()">Update One Value</button>
      </div>
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :defaultColDef="defaultColDef"
        :autoGroupColumnDef="autoGroupColumnDef"
        :columnTypes="columnTypes"
        :rowData="rowData"
        :suppressAggFuncInHeader="true"
        :groupDefaultExpanded="groupDefaultExpanded"
        :valueCache="true"
        :getRowId="getRowId"
        @cell-value-changed="onCellValueChanged"></ag-grid-vue>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "q1", type: "quarterFigure" },
      { field: "q2", type: "quarterFigure" },
      { field: "q3", type: "quarterFigure" },
      { field: "q4", type: "quarterFigure" },
      { field: "year", rowGroup: true, hide: true },
      {
        headerName: "Total",
        colId: "total",
        cellClass: ["number-cell", "total-col"],
        aggFunc: "sum",
        valueFormatter: formatNumber,
        valueGetter: totalValueGetter,
      },
      {
        headerName: "Total x 10",
        cellClass: ["number-cell", "total-col"],
        aggFunc: "sum",
        minWidth: 120,
        valueFormatter: formatNumber,
        valueGetter: total10ValueGetter,
      },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      enableCellChangeFlash: true,
    });
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      minWidth: 130,
    });
    const columnTypes = ref<ColTypeDefs>({
      quarterFigure: {
        editable: true,
        cellClass: "number-cell",
        aggFunc: "sum",
        valueFormatter: formatNumber,
        valueParser: function numberParser(params) {
          return Number(params.newValue);
        },
      },
    });
    const rowData = ref<any[] | null>(getData());
    const groupDefaultExpanded = ref(1);
    const getRowId = ref<GetRowIdFunc>((params: GetRowIdParams) => {
      return String(params.data.id);
    });

    function onCellValueChanged() {
      console.log("onCellValueChanged");
    }
    function onExpireValueCache() {
      console.log("onInvalidateValueCache -> start");
      gridApi.value!.expireValueCache();
      console.log("onInvalidateValueCache -> end");
    }
    function onRefreshCells() {
      console.log("onRefreshCells -> start");
      gridApi.value!.refreshCells();
      console.log("onRefreshCells -> end");
    }
    function onUpdateOneValue() {
      const randomId = Math.floor(window.agRandom() * 10) + "";
      const rowNode = gridApi.value!.getRowNode(randomId);
      if (rowNode) {
        const randomCol = ["q1", "q2", "q3", "q4"][
          Math.floor(window.agRandom() * 4)
        ];
        const newValue = Math.floor(window.agRandom() * 1000);
        console.log("onUpdateOneValue -> start");
        rowNode.setDataValue(randomCol, newValue);
        console.log("onUpdateOneValue -> end");
      }
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      autoGroupColumnDef,
      columnTypes,
      rowData,
      groupDefaultExpanded,
      getRowId,
      onGridReady,
      onCellValueChanged,
      onExpireValueCache,
      onRefreshCells,
      onUpdateOneValue,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Expiring Cache through Editing](https://www.ag-grid.com/examples/value-cache/expiring-through-editing/vue3)

> **Note**
>
> It is not possible to partially invalidate the Value Cache, eg it is not possible to invalidate only a portion of the cells. You might think that if you update a cell, then you only need to invalidate that row's data as the Value Getters can only access that row. That is not true - a Value Getter is a function where you can take data from anywhere in the grid and the grid is none the wiser. So if you change any value, then every single Value Getter is potentially impacted as far as the grid is concerned so the whole Value Cache is invalidated.

### Setting to Never Expire

Above details how the cache operates under normal operations. In essence, the Value Cache gets expired whenever the grid is aware of a change to the underlying data. This strategy is the default strategy for the Value Cache. If you want to **persist the cache** when data updates, then set the grid property `valueCacheNeverExpires=true`.

If you have `valueCacheNeverExpires=true`, then the only event that will expire the Value Cache will be the `api.expireValueCache()` method. Use this if your data is changing, but you don't want to execute Value Getters again, or you want to control exactly when the Value Cache is expired.

This example is again almost identical to the example above. The difference here is the Value Cache is turned on but to never invalidate. Note the following:

- When the grid initialises, there are 10 value getter calls. The values are getting cached.
- After you edit a cell, either through the UI or through the API by pressing **'Update One Value'**, the value getters are not called again, so the **Total** and **Total x 10** columns are not correctly refreshed. The grid already executed the value getters for this column, it will not do it again, it will instead take values from the value cache.
- To get the total column to update after edits, press **'Expire Value Cache'** (calls grid API `expireValueCache()`) and then press **'Aggregate Data & Refresh Cells'** (calls grid API `refreshClientSideRowModel('aggregate')` followed by grid API `refreshCells()`).

  The call `refreshClientSideRowModel('aggregate')` is required as aggregations use Value Getters, thus the aggregations at group level (that is the two total column at the two group rows) need aggregation to be re-run for their values to be updated.

  The call `refreshCells()` is required to update the UI, which in turn also calls Value Getters.

#### Never expire Value change

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
  AutoGroupColumnDef,
  CellStyleModule,
  ClientSideRowModelApiModule,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  ColTypeDefs,
  GetRowIdFunc,
  GetRowIdParams,
  GridApi,
  GridOptions,
  GridReadyEvent,
  HighlightChangesModule,
  ModuleRegistry,
  NumberEditorModule,
  RenderApiModule,
  RowApiModule,
  TextEditorModule,
  ValueCacheModule,
  ValueFormatterParams,
  ValueGetterParams,
  enableDevValidations,
} from "ag-grid-community";
import { RowGroupingModule } from "ag-grid-enterprise";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelApiModule,
  RowApiModule,
  RenderApiModule,
  NumberEditorModule,
  TextEditorModule,
  ValueCacheModule,
  HighlightChangesModule,
  CellStyleModule,
  ClientSideRowModelModule,
  RowGroupingModule,
]);

let callCount = 1;

const totalValueGetter = function (params: ValueGetterParams) {
  const q1 = params.getValue("q1");
  const q2 = params.getValue("q2");
  const q3 = params.getValue("q3");
  const q4 = params.getValue("q4");
  const result = q1 + q2 + q3 + q4;
  console.log(
    "Total Value Getter (" +
      callCount +
      ", " +
      params.column.getId() +
      "): " +
      [q1, q2, q3, q4].join(", ") +
      " = " +
      result,
  );
  callCount++;
  return result;
};

const total10ValueGetter = function (params: ValueGetterParams) {
  const total = params.getValue("total");
  return total * 10;
};

function formatNumber(params: ValueFormatterParams) {
  const number = params.value;
  return Math.floor(number).toLocaleString();
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <div style="height: 100%; box-sizing: border-box; padding-top: 45px">
      <ag-grid-vue
        style="width: 100%; height: 100%;"
        @grid-ready="onGridReady"
        :columnDefs="columnDefs"
        :defaultColDef="defaultColDef"
        :autoGroupColumnDef="autoGroupColumnDef"
        :columnTypes="columnTypes"
        :valueCache="true"
        :valueCacheNeverExpires="true"
        :rowData="rowData"
        :suppressAggFuncInHeader="true"
        :groupDefaultExpanded="groupDefaultExpanded"
        :getRowId="getRowId"
        @cell-value-changed="onCellValueChanged"></ag-grid-vue>
      </div>
      <div style="position: absolute; top: 0; left: 15px">
        <button v-on:click="onUpdateOneValue()">Update One Value</button>
        <button v-on:click="onExpireValueCache()">Expire Value Cache</button>
        <button v-on:click="onRefreshCells()">Aggregate Data &amp; Refresh Cells</button>
      </div>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      { field: "q1", type: "quarterFigure" },
      { field: "q2", type: "quarterFigure" },
      { field: "q3", type: "quarterFigure" },
      { field: "q4", type: "quarterFigure" },
      { field: "year", rowGroup: true, hide: true },
      {
        headerName: "Total",
        colId: "total",
        cellClass: ["number-cell", "total-col"],
        aggFunc: "sum",
        valueFormatter: formatNumber,
        valueGetter: totalValueGetter,
      },
      {
        headerName: "Total x 10",
        cellClass: ["number-cell", "total-col"],
        aggFunc: "sum",
        minWidth: 120,
        valueFormatter: formatNumber,
        valueGetter: total10ValueGetter,
      },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      enableCellChangeFlash: true,
    });
    const autoGroupColumnDef = ref<AutoGroupColumnDef>({
      minWidth: 130,
    });
    const columnTypes = ref<ColTypeDefs>({
      quarterFigure: {
        editable: true,
        cellClass: "number-cell",
        aggFunc: "sum",
        valueFormatter: formatNumber,
        valueParser: function numberParser(params) {
          return Number(params.newValue);
        },
      },
    });
    const rowData = ref<any[] | null>(getData());
    const groupDefaultExpanded = ref(1);
    const getRowId = ref<GetRowIdFunc>((params: GetRowIdParams) => {
      return String(params.data.id);
    });

    function onCellValueChanged() {
      console.log("onCellValueChanged");
    }
    function onExpireValueCache() {
      console.log("onInvalidateValueCache -> start");
      gridApi.value!.expireValueCache();
      console.log("onInvalidateValueCache -> end");
    }
    function onRefreshCells() {
      console.log("onRefreshCells -> start");
      gridApi.value!.refreshClientSideRowModel("aggregate");
      gridApi.value!.refreshCells();
      console.log("onRefreshCells -> end");
    }
    function onUpdateOneValue() {
      const randomId = Math.floor(window.agRandom() * 10) + "";
      const rowNode = gridApi.value!.getRowNode(randomId);
      if (rowNode) {
        const randomCol = ["q1", "q2", "q3", "q4"][
          Math.floor(window.agRandom() * 4)
        ];
        const newValue = Math.floor(window.agRandom() * 1000);
        console.log("onUpdateOneValue -> start");
        rowNode.setDataValue(randomCol, newValue);
        console.log("onUpdateOneValue -> end");
      }
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      autoGroupColumnDef,
      columnTypes,
      rowData,
      groupDefaultExpanded,
      getRowId,
      onGridReady,
      onCellValueChanged,
      onExpireValueCache,
      onRefreshCells,
      onUpdateOneValue,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Never expire Value change](https://www.ag-grid.com/examples/value-cache/never-expire/vue3)
